#include <stdio.h>
#include <signal.h>
#include <ctype.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netinet/tcp.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <sys/time.h>           /* struct timeval */

struct sockaddr_in sinme;
struct sockaddr_in sinhim;
struct sockaddr_in frominet;

extern int errno;


void err();
void mes();
int Nread();
int Nwrite();

void sigpipe() {}
Usage()
{
 fputs( "Usage: client -h host [-p port] -n STATname -v values \n"
                  "       port - 5001 default\n",
  stderr
 );

 exit( -2 );
}



main( int argc, char *argv[] )
{
 int domain, fromlen;
 int fd;                         /* fd of network socket */

 short KeepAlive= 0;
 short port= 5001;               /* TCP port number */
 char *name= NULL;                /* STAT name */
 char *vals= NULL;                /* STAT values */
 char *host= NULL;               /* ptr to name of host */
 struct hostent *addr;
 unsigned long addr_tmp;
 int i, cnt, sst;
 char buff[1024];
 long T0, T1;

 if( argc < 3 )  Usage();

 for( i= 1; i < argc; i++ )
 {
  if( strcmp( argv[i], "-p" ) == 0 )  { port= atoi( argv[++i] );  continue;  }
  if( strcmp( argv[i], "-h" ) == 0 )  { host= argv[++i];          continue;  }
  if( strcmp( argv[i], "-n" ) == 0 )  { name= argv[++i];           continue;  }
  if( strcmp( argv[i], "-v" ) == 0 )  { vals= argv[++i];           continue;  }

  Usage();
 }

 if( host == NULL || name == NULL || strlen(name) == 0
  || vals == NULL || strlen(vals) == 0 )
  Usage();

 bzero((char *)&sinhim, sizeof(sinhim));

 if (atoi(host) > 0 )
 {
  /* Numeric */
  sinhim.sin_family = AF_INET;
  sinhim.sin_addr.s_addr = inet_addr(host);
 }
 else
 {
  if( (addr= gethostbyname( host )) == NULL )   err( "bad hostname" );
  sinhim.sin_family = addr->h_addrtype;
  bcopy(addr->h_addr,(char*)&addr_tmp, addr->h_length);
  sinhim.sin_addr.s_addr= addr_tmp;
 }

 sinhim.sin_port = htons(port);
 sinme.sin_port = 0;             /* free choice */
#if defined(__convex__)
 sinme.sin_family = AF_INET;
#endif

  if( (fd= socket( AF_INET, SOCK_STREAM, 0)) < 0 )    err("socket");
  if( bind( fd, &sinme, sizeof(sinme) ) < 0 )         err("bind");
  signal(SIGPIPE, sigpipe);

  if( connect( fd, &sinhim, sizeof(sinhim) ) < 0 ) err("connect");

  if( Nwrite( fd, name, strlen(name) ) <= 0 )  err( "Nwrite" );

  while(1)
  {
   sleep(10);
   if( Nwrite( fd, vals, strlen(vals) ) <= 0 )  err( "Nwrite" );
  }

 close( fd );
 exit( 0 );
}

void err( char *s )
{
 perror( s );
 fprintf( stderr, "errno= %d\n", errno );
 exit( -2 );
}

void mes( char *s)
{
 fprintf( stderr, "client pid-%d: %s\n", getpid(), s );
}


/*
 *                      N R E A D
 */
Nread( fd, buf, count )
int fd;
char *buf;
int count;
{
 int cnt;
 cnt= read( fd, buf, count );
 if( cnt >= 0 ) buf[cnt]= 0;
 return( cnt );
}

/*
 *                      N W R I T E
 */
Nwrite( fd, buf, count )
int fd;
char *buf;
int count;
{
 return( write( fd, buf, count ) );
}

